import java.util.ArrayList;

class Koerper {
	private int gewicht;

	public Koerper(int gewicht) {
		this.gewicht = gewicht > 0 ? gewicht : 1;
	}

	public int getGewicht() {
		return this.gewicht;
	}

	public void setGewicht(int gewicht) {
		this.gewicht = gewicht;
	}
}

class Balkenwaage {

	private ArrayList<Koerper> links;
	private ArrayList<Koerper> rechts;

	public Balkenwaage() {
		this.links = new ArrayList<Koerper>();
		this.rechts = new ArrayList<Koerper>();
	}

	public void hinzufuegenLinks(Koerper koerper) {
		this.entfernen(koerper);
		this.links.add(koerper);
	}

	public void hinzufuegenRechts(Koerper koerper) {
		this.entfernen(koerper);
		this.rechts.add(koerper);
	}

	public void entfernen(Koerper koerper) {
		if (!this.links.remove(koerper)) {
			this.rechts.remove(koerper);
		}
	}

	public boolean isInWaage() {
		return Balkenwaage.getGesamtGewicht(this.links) == Balkenwaage
				.getGesamtGewicht(this.rechts);
	}

	public boolean schwererLinks() {
		return Balkenwaage.getGesamtGewicht(this.links) > Balkenwaage
				.getGesamtGewicht(this.rechts);
	}

	@Override
	public String toString() {
		return Balkenwaage.getGesamtGewicht(this.links) + ":"
				+ Balkenwaage.getGesamtGewicht(this.rechts);
	}

	private static int getGesamtGewicht(ArrayList<Koerper> seite) {
		int gewicht = 0;
		for (Koerper k : seite) {
			gewicht += k.getGewicht();
		}
		return gewicht;
	}
}

public class UE16Aufgabe13 {
	public static void main(String[] args) {
		Balkenwaage waage = new Balkenwaage();
		Koerper k1 = new Koerper(10);
		Koerper k2 = new Koerper(5);
		waage.hinzufuegenLinks(k1);
		waage.hinzufuegenRechts(k2);
		while (waage.schwererLinks()) {
			waage.hinzufuegenRechts(new Koerper(1));
		}
		System.out.println(waage.isInWaage());
		waage.hinzufuegenRechts(k1);
		waage.entfernen(k2);
		System.out.println(waage.toString());
	}

}
